﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Telerik.Windows.Controls.DragDrop;
using Telerik.Windows.Controls;

namespace WpfApplication1
{
	/// <summary>
	/// Interaction logic for TreeViewUserControl.xaml
	/// </summary>
	public partial class TreeViewUserControl : UserControl
	{
		private bool dragStarted;

		public TreeViewUserControl()
		{
			InitializeComponent();
			Dispatcher.BeginInvoke(new Action(() =>
			{
				var parentWindow = this.ParentOfType<Window>();
				if(parentWindow != null)
				{
					parentWindow.AddHandler(FrameworkElement.MouseRightButtonDownEvent, new MouseButtonEventHandler(TreeViewUserControl_MouseRightButtonDown), true);
				}
				else
				{
					MessageBox.Show("Error! Missing parent window!");
				}
			}), System.Windows.Threading.DispatcherPriority.ApplicationIdle);
		}

		void TreeViewUserControl_MouseRightButtonDown(object sender, MouseButtonEventArgs e)
		{
			if (this.dragStarted)
			{
				RadDragAndDropManager.CancelDrag();
			}
		}

		private void treeView1_DragStarted(object sender, Telerik.Windows.Controls.RadTreeViewDragEventArgs e)
		{
			this.dragStarted = true;
		}

		private void treeView1_DragEnded(object sender, Telerik.Windows.Controls.RadTreeViewDragEndedEventArgs e)
		{
			this.dragStarted = false;
		}
	}
}
